#include <stdio.h>
#include "led_key.h"
#include <wiringPi.h>
#include <unistd.h>
#include <stdint.h>


//define pin conection in wringpi number
/****************************
* PIN_D1     7 
* PIN_D2     1 
* PIN_K1     2
* PIN_K2     3
***************************/

void LED_KEY_Init(void)
{
	if(wiringPiSetup() < 0)//use wiringpi Pin number
    { 
        printf("wiringPi lib init failed! \r\n");
    }
	pinMode(PIN_D1, OUTPUT);
    pinMode(PIN_D2, OUTPUT);
    pinMode(PIN_K1, INPUT);
    pullUpDnControl(PIN_K1, PUD_UP);
    pinMode(PIN_K2, INPUT);
    pullUpDnControl(PIN_K2, PUD_UP);
}

void Led_key_task(void)
{
	int k1_flag = 0;
	int k2_flag = 0;	
	printf("Led Key Task\r\n");
	for(;;)
	{
	    //K1 key
	    if(digitalRead(PIN_K1) == LOW && k1_flag == 0)
	    {
	        delay(10);
			if(digitalRead(PIN_K1) == LOW) // make sure the button has been pressed
			{
				k1_flag = 1;
				digitalWrite(PIN_D1,1);
				printf("K1 Press\r\n");
			}
	    }
	    else if(digitalRead(PIN_K1) == HIGH && k1_flag == 1) // key has been released
	    {
			k1_flag = 0;
			digitalWrite(PIN_D1,0);
	    } 
	    //K2 key
	    if(digitalRead(PIN_K2) == LOW && k2_flag == 0)
	    {
	        delay(10);
			if(digitalRead(PIN_K2) == LOW) // make sure the button has been pressed
			{
				k2_flag = 1;
				digitalWrite(PIN_D2,1);
				printf("K2 Press\r\n");
			}
	    }
	    else if(digitalRead(PIN_K2) == HIGH && k2_flag == 1) // key has been released
	    {
			k2_flag = 0;
			digitalWrite(PIN_D2,0);
	    } 
	}
}


/***********************************************************
						end file
***********************************************************/

